/*
 *  syscall.c
 *
 *   ""  .
 */

/* 
 * Copyright (C) 2001 by Peter Jay Salzman 
 */

/* 
 *   
 */

#include <linux/kernel.h>      /* -    ! */
#include <linux/module.h>      /*     */
#include <linux/moduleparam.h> /*     */
#include <linux/unistd.h>      /*    */

/* 
 * ,   
 * user id  . 
 */
#include <linux/sched.h>
#include <asm/uaccess.h>

/* 
 *    (  ). 
 *        .
 *
 * sys_call_table     2.6.x.
 *      ˹ ,
 *    ""     
 */
extern void *sys_call_table[];

/* 
 * UID ,   "",
 *    
 */
static int uid;
module_param(uid, int, 0644);

/* 
 *    ,   .
 *   ,  ,    
 * ,  ,    
 * ,   
 *    100% ,   ,
 *  sys_open      .
 *
 *   --       sys_open.
 *     .
 */
asmlinkage int (*original_call) (const char *, int, int);

/* 
 * ,  sys_open (
 *  ,       open).
 *  ,     
 *    fs/open.c.
 *
 *  -  ""   
 *  .  --  
 *     ,
 *        
 *        .
 */
asmlinkage int our_sys_open(const char *filename, int flags, int mode)
{
  int i = 0;
  char ch;

  /* 
   *  --   ?
   */
  if (uid == current->uid) {
    /* 
     * 
     */
    printk("Opened file by %d: ", uid);
    do {
      get_user(ch, filename + i);
      i++;
      printk("%c", ch);
    } while (ch != 0);
    printk("\n");
  }

  /* 
   *      sys_open - 
   *     
   */
  return original_call(filename, flags, mode);
}

/* 
 *   -   
 */
int init_module()
{
  /* 
   *  -  , 
   *     ... 
   */
  printk("I'm dangerous. I hope you did a ");
  printk("sync before you insmod'ed me.\n");
  printk("My counterpart, cleanup_module(), is even");
  printk("more dangerous. If\n");
  printk("you value your file system, it will ");
  printk("be \"sync; rmmod\" \n");
  printk("when you remove this module.\n");

  /* 
   *     
   *   original_call,    
   *    
   */
  original_call = sys_call_table[__NR_open];
  sys_call_table[__NR_open] = our_sys_open;

  /* 
   *      
   *   foo,    sys_call_table[__NR_foo]. 
   */

  printk("Spying on UID:%d\n", uid);

  return 0;
}

/* 
 *    -      
 */
void cleanup_module()
{
  /* 
   *    
   */
  if (sys_call_table[__NR_open] != our_sys_open) {
    printk("Somebody else also played with the ");
    printk("open system call\n");
    printk("The system may be left in ");
    printk("an unstable state.\n");
  }

  sys_call_table[__NR_open] = original_call;
}
