/*
 *  sched.c -    .
 *
 *  Copyright (C) 2001 by Peter Jay Salzman
 */

/* 
 *   
 */

/* 
 * ,   
 */
#include <linux/kernel.h>    /* -    ! */
#include <linux/module.h>    /*     */
#include <linux/proc_fs.h>	 /*     /proc */
#include <linux/workqueue.h> /*   */
#include <linux/sched.h>     /*    */
#include <linux/init.h>      /*   __init   __exit */
#include <linux/interrupt.h> /*  irqreturn_t */

struct proc_dir_entry *Our_Proc_File;
#define PROC_ENTRY_FILENAME "sched"
#define MY_WORK_QUEUE_NAME "WQsched.c"

/* 
 *    
 */
static int TimerIntrpt = 0;

static void intrpt_routine(void *);

static int die = 0;  /* 1 --   */

/* 
 *  ,   ,      (workqueue.h)
 */
static struct workqueue_struct *my_workqueue;

static struct work_struct Task;
static DECLARE_WORK(Task, intrpt_routine, NULL);

/* 
 * -   .      void*
 *        .
 */
static void intrpt_routine(void *irrelevant)
{
  /* 
   *  
   */
  TimerIntrpt++;

  /* 
   *    ,       
   */
  if (die == 0)
    queue_delayed_work(my_workqueue, &Task, 100);
}

/* 
 *     /proc.
 */
ssize_t
procfile_read(char *buffer,
        char **buffer_location,
        off_t offset, int buffer_length, int *eof, void *data)
{
  int len;		/*     */

  /* 
   *    static,      
   * ,    
   */
  static char my_buffer[80];

  static int count = 1;

  /* 
   *      , ,   != 0,  
   *    ,   0,     .
   */
  if (offset > 0)
    return 0;

  /* 
   *      
   */
  len = sprintf(my_buffer, "Timer called %d times so far\n", TimerIntrpt);
  count++;

  /* 
   *   
   */
  *buffer_location = my_buffer;

  /* 
   *   
   */
  return len;
}

/* 
 *   -    /proc
 */
int __init init_module()
{
  int rv = 0;
  /* 
   *            
   */
  my_workqueue = create_workqueue(MY_WORK_QUEUE_NAME);
  queue_delayed_work(my_workqueue, &Task, 100);

  Our_Proc_File = create_proc_entry(PROC_ENTRY_FILENAME, 0644, NULL);
  Our_Proc_File->read_proc = procfile_read;
  Our_Proc_File->owner = THIS_MODULE;
  Our_Proc_File->mode = S_IFREG | S_IRUGO;
  Our_Proc_File->uid = 0;
  Our_Proc_File->gid = 0;
  Our_Proc_File->size = 80;

  if (Our_Proc_File == NULL) {
    rv = -ENOMEM;
    remove_proc_entry(PROC_ENTRY_FILENAME, &proc_root);
    printk(KERN_INFO "Error: Could not initialize /proc/%s\n",
           PROC_ENTRY_FILENAME);
  }

  return rv;
}

/* 
 *  
 */
void __exit cleanup_module()
{
  /* 
   *    /proc
   */
  remove_proc_entry(PROC_ENTRY_FILENAME, &proc_root);
  printk(KERN_INFO "/proc/%s removed\n", PROC_ENTRY_FILENAME);

  die = 1;                    /*        */
  cancel_delayed_work(&Task); 
  flush_workqueue(my_workqueue); /*     */
  destroy_workqueue(my_workqueue);

  /* 
   *  ,  intrpt_routine     . 
   *  ,    ,   .
   */

}

/* 
 *  ,   work_queue 
 *       GPL
 */
MODULE_LICENSE("GPL");
